package com.community.huiju.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.community.commom.ailiyun.AESDecode;
import com.community.commom.constant.Constant;
import com.community.commom.mode.ResponseBean;
import com.community.huiju.common.PicUtils;
import com.community.huiju.common.hk.HKConstant;
import com.community.huiju.dao.TaFaceMapper;
import com.community.huiju.dao.TaSysRoleMapper;
import com.community.huiju.dao.TaUserMapper;
import com.community.huiju.model.TaFace;
import com.community.huiju.model.TaSysRole;
import com.community.huiju.model.TaUser;
import com.community.huiju.service.FaceServiceI;
import com.community.huiju.service.ImageServiceI;
import com.hikvision.cms.api.common.util.Digests;
import com.hikvision.cms.api.common.util.HttpClientSSLUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

@Service("faceServicel")
@Transactional
public class FaceServicelimpl implements FaceServiceI {


    @Autowired
    private TaFaceMapper taFaceMapper;

    @Autowired
    private TaUserMapper taUserMapper;

    @Autowired
    private TaSysRoleMapper taSysRoleMapper;

    @Autowired
    private ImageServiceI imageServiceI;

    @Override
    public ResponseBean addFace(Integer userid,MultipartFile uploadFile) {
        String faceImg = null;
        try {
            faceImg=imageServiceI.getImageUrl(uploadFile);
        } catch (IOException e) {
            e.printStackTrace();
        }
        TaUser user=taUserMapper.selectByPrimaryKey(userid);
        ResponseBean response = new ResponseBean();
        TaFace taFace = new TaFace();
        taFace.setCommunityId(user.getCommunityId());
        taFace.setTaUserId(userid);
        taFace.setCreateUser(userid);
        taFace.setUpdateUser(userid);
        taFace.setCreateDate(new Date());
        taFace.setUpdateDate(new Date());
        //已登陆，身份未知，状态未知


        //判断身份是否为业主且状态为已停用
        TaSysRole sysRole = taSysRoleMapper.findRoleByUserId(userid);
        TaUser taUser = taUserMapper.selectByPrimaryKey(userid);
        if (Constant.INVALID.equals(taUser.getStatus())
                && Constant.OWNER.equals(sysRole.getRoleName())) {

            response.addError("9996", "您的身份已停用，请联系物业");
            return response;
        }

        //身份为家属租客，状态为已停用
        if (Constant.INVALID.equals(taUser.getStatus())
                && (Constant.RELATION.equals(sysRole.getRoleName())) || Constant.TENANT.equals(sysRole.getRoleName())) {

            response.addError("9996", "您的身份已停用，请联系物业");
            return response;
        }

        //查询当前用户是否有人脸记录
        TaFace User = taFaceMapper.getByUserId(userid);
        if (null == User) {
            boolean isA=true;
            if (Constant.OWNER.equals(sysRole.getRoleName()) && "1".equals(taUser.getVerifyStatus())) {
                ResponseBean responseBean = new ResponseBean();
                Object resps=checKout(faceImg,taFace,isA,null,user.getUserName(),uploadFile);
                if (null!=resps && "true".equals(resps)) {
                    responseBean.addSuccess("图片录入成功");
                }else {
                    if ("1".equals(resps)) {
                        responseBean.addError("7772", "推送海康服务器失败");
                    }else {
                        responseBean.addError("7771","请录入正确的图片");
                    }
                }
                return responseBean;
            }
            //家属或者租客，已认证
            if (Constant.RELATION.equals(sysRole.getRoleName()) || Constant.TENANT.equals(sysRole.getDescription()) && "1".equals(taUser.getVerifyStatus())) {
                ResponseBean responseBeans = new ResponseBean();
                Object resps=checKout(faceImg,taFace,isA,null,user.getUserName(),uploadFile);
                if (null!=resps && "true".equals(resps)) {
                    imgPush(user.getUserName(), uploadFile);
                    responseBeans.addSuccess("图片录入成功");
                }else {
                        if ("1".equals(resps)) {
                            responseBeans.addError("7772", "推送海康服务器失败");
                        }else {
                            responseBeans.addError("7771","请录入正确的图片");
                        }
                }
                return responseBeans;
            }
        }
        return response;
    }

    @Override
    public ResponseBean upDateFace(Integer userId,MultipartFile uploadFile) {
        boolean isA=false;
        String faceImg = null;
        try {
            faceImg=imageServiceI.getImageUrl(uploadFile);
        } catch (IOException e) {
            e.printStackTrace();
        }
        TaUser user=taUserMapper.selectByPrimaryKey(userId);
        ResponseBean responseBean = new ResponseBean();
        TaFace taFace = new TaFace();
        taFace.setCommunityId(user.getCommunityId());
        taFace.setTaUserId(userId);
        taFace.setUpdateUser(userId);
        taFace.setUpdateDate(new Date());
        Object resps=checKout(faceImg,taFace,isA,userId,user.getUserName(),uploadFile);
        if (null!=resps && "true".equals(resps)) {
            responseBean.addSuccess("修改成功");
        }else {
            if ("1".equals(resps)) {
                responseBean.addError("7772", "推送海康服务器失败");
            }else {
                responseBean.addError("7771","请录入正确的图片");
            }
        }
        return responseBean;
    }
    
    /**
     * 人脸录入验证
     */
    public Object checKout(String faceImg, TaFace taFace, boolean isA,Integer user,String name,MultipartFile uploadFile) {
        AESDecode aesd = new AESDecode();
        String body = "{\"type\": \"0\", \"image_url\":\"" + faceImg + "\"}";
        try {
            ResponseBean responseBean = aesd.send(body);
            JSONObject jsonObject = JSONObject.parseObject(responseBean.getMessage());
            Integer type = (Integer) jsonObject.get("errno");
            Integer faceNum= (Integer) jsonObject.get("face_num");
            if (0==type && null!=faceNum && 1==faceNum && isA) {
                //校验通过后
                String errorCode= (String) imgPush(name, uploadFile);
                JSONObject Code = JSONObject.parseObject(errorCode);
                Integer personGroupId = (Integer) Code.get("personGroupId");
                if (null!=personGroupId && personGroupId == 1) {
                    taFace.setFaceImg(faceImg);
                    taFaceMapper.insertSelective(taFace);
                    return true;
                }else{
                    String code="1";
                    return code;
                }
            }else if (0==type && null!=faceNum && 1==faceNum && isA==false){

                taFace.setFaceImg(faceImg);
                taFaceMapper.updateByPrimaryKeySelective(taFace);
                return true;
            }

        } catch (Exception e) {
            e.printStackTrace();
        }
        return false;
    }
    
    /**
     * 在图片验证通过的情况下，推送到海康
     * @param name
     * @param uploadFile
     * @return
     */
    public Object imgPush(String name,MultipartFile uploadFile){
        //把图片压缩成100K以下
        // 压缩后的图片字节数组
        byte [] picByte = null;
        try {
            long l = System.currentTimeMillis();
            byte[] bytes  = uploadFile.getBytes();
            // 拿到转换后的图片字节
            picByte= PicUtils.compressPicForScale(bytes,99L,"x");
        } catch (IOException e) {
            e.printStackTrace();
        }
        // 推送海康服务器
        String imgs = PicUtils.getImgStr(picByte);
        String pgId= (String) HKpersonGroupId();
        JSONObject jsonObject = JSONObject.parseObject(pgId);
        Integer personGroupId = (Integer) jsonObject.get("personGroupId");
        System.out.println(personGroupId);
        String url = HKConstant.OPENAPI_IP_PORT_HTTP + HKConstant.OP_IMG;
        Map<String, Object> map = new HashMap<String, Object>();
        map.put("appkey", HKConstant.APPKEY);
        map.put("time", System.currentTimeMillis());
        map.put("token", HKConstant.SECRET);
        map.put("opUserUuid",HKConstant.OP_USER_UUID);
        map.put("facePhotos", imgs);
        map.put("personName",name);
        map.put("personGroupId",personGroupId);
        map.put("birthday",System.currentTimeMillis());
        String params =  JSON.toJSONString(map);
        System.out.println(" ====== testGetDefaultUserUUID 请求参数：【" + params + "】");
        String data = null;
        try {

            data = HttpClientSSLUtils.doPost(url + "?token=" + Digests.buildToken(url + "?" + params, params, HKConstant.SECRET), params);
        } catch (Exception e) {
            e.printStackTrace();
        }
        System.out.println(" ====== testGetDefaultUserUUID 请求返回结果：【{" + data + "}】");
        return data;
    }
    
    /**
     * 把图片推送海康，需要获得海康人员分组下的
     * @return
     */
    public Object HKpersonGroupId(){
        String url = HKConstant.OPENAPI_IP_PORT_HTTP + HKConstant.OP_PERSON_ID;
        Map<String, Object> map = new HashMap<String, Object>();
        map.put("appkey", HKConstant.APPKEY);
        map.put("time", System.currentTimeMillis());
        map.put("token", HKConstant.SECRET);
        map.put("opUserUuid",HKConstant.OP_USER_UUID);
        map.put("pageNo",1);
        map.put("pageSize",100);
        map.put("birthday",System.currentTimeMillis());
        String params =  JSON.toJSONString(map);
        String data = null;
        try {
            data = HttpClientSSLUtils.doPost(url + "?token=" + Digests.buildToken(url + "?" + params, params, HKConstant.SECRET), params);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return data;
    }

}
